Attribute VB_Name = "modAutoComplete"
'Created by Liam Bowers, AKA Lima.
'liam@liamz.freeserve.co.uk
'ICQ: 27879674

'I'm appreciative to any constructive comments you might have.
'If anyone would like to do a joint project or would like any help with anything
'then please get in touch. I dont claim to be brilliant with vb, but i know my stuff!
'Cheers, Lima

Option Base 1
Public Word() As String 'The string that the words will be stored in
Public WordCount As Integer
Public Const FindMatchLetterCount As Integer = 1 'How many Characters you have to type before it starts to finish the words
Public WordList As String ' = "wordlist.txt"
Public AutoCompleteActive As Boolean
Sub Main()
frmMain.Show
WordList = App.Path & "\wordlist.txt"
Call LoadWords
Call SortWords
frmMain.Caption = "Words: " & WordCount
End Sub
Sub AutoComplete(MyTextBox As TextBox)
Dim CurrentPartialWord As String, NearestMatch As String, ExtraBit As String

If AutoCompleteActive = False Then Exit Sub 'If there has been a problem loading the word list, then this will be false.
CurrentPartialWord = GetWord(MyTextBox) 'calls the sub that grabs current word.

If Trim(CurrentPartialWord) = "" Then Exit Sub 'if there is no current word then dont go any further
If Len(CurrentPartialWord) < FindMatchLetterCount Then Exit Sub 'if the word isn't big enough to fit the 'letter count' criteria.
NearestMatch = FindNearestMatch(CurrentPartialWord)
If Len(NearestMatch) = 0 Then Exit Sub 'if it didnt find a match... exit the sub
ExtraBit = Right(NearestMatch, Len(NearestMatch) - Len(CurrentPartialWord)) 'work out the part of word to add to the textbox
'MsgBox "Partial Word: " & CurrentPartialWord & vbNewLine _
& "Nearest Match: " & NearestMatch & vbNewLine _
& "'Bit' to add: " & ExtraBit


MyTextBox.SelText = ExtraBit 'adds the extra bit FIRST
MyTextBox.SelStart = MyTextBox.SelStart - Len(ExtraBit) 'starts the setstart at the start of the word...
MyTextBox.SelLength = Len(ExtraBit) 'and highlights the 'extra' bit of the word.
End Sub
Function GetWord(MyTextBox As TextBox) As String
MyTextBox = frmMain.txtText
Dim tempPosition As Integer, i As Integer
Dim tempWordLength As Integer, tempWord As String
tempPosition = MyTextBox.SelStart
If tempPosition = 0 Then Exit Function 'if it is the start of the text box, exit the function.
For i = tempPosition To 1 Step -1 'from the cursor position, count down to the 1st character.
    Select Case Asc(Mid(MyTextBox.Text, i, 1)) 'select the character
        Case 65 To 90, 97 To 122 'when it finds a normal character, keep going
        Case 33 To 64, 91 To 96, 123 To 159, 161 To 255
        Case Else 'if if finds any other character, class it as the start of the word
            Exit For
    End Select
    tempPosition = i
Next i
tempWordLength = MyTextBox.SelStart - i 'works out the word length
GetWord = LCase(Trim(Mid(MyTextBox.Text, tempPosition, tempWordLength))) 'grabs the current word.
End Function
Function FindNearestMatch(SubjectWord As String) As String
Dim i As Integer
For i = LBound(Word) To UBound(Word) 'from the lowest to the highest array entries.
    If LCase(SubjectWord) = Left(LCase(Word(i)), Len(SubjectWord)) Then 'if it finds an entry that is the same as the partial word, grab it and exit the function.
        FindNearestMatch = Word(i): Exit Function
    ElseIf LCase(SubjectWord) < Left(LCase(Word(i)), Len(SubjectWord)) Then 'when it scrolls through the words and 'goes past' any possible matches, stop searching and return nowt.
        Exit Function
    End If
Next i
End Function
Sub SortWords() 'simply sorts the array...
Dim SwapWordNum As Integer
Dim Swapped As Boolean
    SwapWordNum = WordCount
Dim j As Integer
For j = 1 To SwapWordNum
    Swapped = True
    Do Until Swapped = False
        Dim i As Integer
        For i = 1 To SwapWordNum
            Swapped = False
            If i = WordCount Then Exit For
            If LCase(Word(i)) > LCase(Word(i + 1)) Then
                Call SwapWord(i, i + 1)
                Swapped = True
            End If
        Next i
        SwapWordNum = SwapWordNum - 1
    Loop
Next j
End Sub
Sub LoadWords() 'loads the words from text file(see the constant) in to the array
Dim tempWord As String
On Error GoTo err 'if it finds an error goto 'err:'
Open WordList For Input As #1 'open the word list for input.
    Do While Not EOF(1) 'keep going until it get's to the end of the file...
        Line Input #1, tempWord 'grab the line, and put it in to the 'tempWord' array.
        tempWord = Trim(tempWord) 'trim the word...
        If Len(tempWord) > 0 Then 'if the word isn't 'nothing'.....
            If Left(tempWord, 1) <> "#" Then Call AddWord(tempWord) 'if the word hasn't got a '#' in front of it, add the word. - '#' could be used for a comment
            DoEvents
        End If
    Loop
Close #1 'close the file
AutoCompleteActive = True 'allow the autocomplete to run
Exit Sub
err: 'get's called when it finds an error
Close #1 'closes the file
AutoCompleteActive = False 'DOESNT allow the autocomplete to run.
End Sub
Sub AddWord(NewWord As String) 'adds the word to the array.
Dim tempWordCount As Integer
tempWordCount = WordCount + 1
ReDim Preserve Word(tempWordCount) As String 'resizes the array, preserving the data.
Word(tempWordCount) = LCase(NewWord)
WordCount = tempWordCount
End Sub
Sub SwapWord(Word1Num As Integer, Word2Num As Integer) 'swaps 2 words.
Dim tempWord As String
tempWord = Word(Word1Num)
Word(Word1Num) = Word(Word2Num)
Word(Word2Num) = tempWord
End Sub
